<?php

namespace seraph_dlstat;

if( !defined( 'ABSPATH' ) )
	exit;

function OnApi_Get( $args )
{
	Plugin::ApiCall_EnableOutput();

	$uri = @$args[ 'uri' ];
	if( empty( $uri ) )
	{
		wp_die( '', 400 );
		return;
	}

	$uri = ltrim( $uri, '/' );
	unset( $args[ 'uri' ] );

	$pathSite = null;
	{
		$siteUrlParts = @parse_url( get_site_url() );
		if( empty( $siteUrlParts ) )
		{
			wp_die( '', 500 );
			return;
		}

		$pathSite = Gen::SetLastSlash( ltrim( @$siteUrlParts[ 'path' ], '/' ) );
	}

	_PostEvent( $uri, $args );

	$itemLocalPath = ABSPATH . substr( $uri, strlen( $pathSite ) );
	Fs::StreamOutFileContent( $itemLocalPath, Fs::MimeTypeDef, $_SERVER[ 'REQUEST_METHOD' ] != 'GET', 16384 );
}

function _PostEvent( $uri, $args )
{
	$sett = Plugin::SettGet();

	$ip = $_SERVER[ 'REMOTE_ADDR' ];
	{

	}

	$info = array();
	$info[ 'time' ] = time();
	$info[ 'ip' ] = $ip;
	$info[ 'user_agent' ] = $_SERVER[ 'HTTP_USER_AGENT' ];
	$info[ 'uri' ] = $uri;
	$info[ 'args' ] = $args;

	if( Gen::GetArrField( $sett, 'evtSendSched', true, '/' ) )
		_PostponeEvent( $sett, $info );
	else
		_ProcessEvents( $sett, array( $info ) );
}

